/*
 *    movegen.c
 *              - generovani a provadeni tahu
 *
 */

#include <stdio.h>
#include "data.h"

/* lokalni funkce */

void MoveGenKolm(TGame *, TMoveList, int *, int, int);
void MoveGenSikm(TGame *, TMoveList, int *, int, int);

int MoveGen(TGame * aGame, TMoveList aList, int MM)
{
	int mp = 0, i = 1;
	TPlayer *lPlayer;
	TPieceData *lPiece;
	TSquare to;
	TMove lMove;
	char lMoveStr[/*5*/6]; // Roland
	if (aGame->sidetomove == WHITE) {
		MoveGenKolm(aGame, aList, &mp, WQEN, MM);
		if (MM && mp)
			return 1;
		MoveGenSikm(aGame, aList, &mp, WQEN, MM);
		if (MM && mp)
			return 1;
		MoveGenKolm(aGame, aList, &mp, WROK, MM);
		if (MM && mp)
			return 1;
		MoveGenSikm(aGame, aList, &mp, WBSP, MM);
		if (MM && mp)
			return 1;
		lPlayer = &(aGame->whiteplayer);
	} else {
		MoveGenKolm(aGame, aList, &mp, BQEN, MM);
		if (MM && mp)
			return 1;
		MoveGenSikm(aGame, aList, &mp, BQEN, MM);
		if (MM && mp)
			return 1;
		MoveGenKolm(aGame, aList, &mp, BROK, MM);
		if (MM && mp)
			return 1;
		MoveGenSikm(aGame, aList, &mp, BBSP, MM);
		if (MM && mp)
			return 1;
		lPlayer = &(aGame->blackplayer);
	}
	while (i < 16 && (lPlayer->pieces[i].fig != EMPT)) {
		lPiece = &(lPlayer->pieces[i]);
		switch (lPiece->fig) {
		case WKNT:
		case BKNT:
			to.x = lPiece->pos.x;
			to.y = lPiece->pos.y;
			to.x = lPiece->pos.x + 2;
			to.y = lPiece->pos.y - 1;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x + 2;
			to.y = lPiece->pos.y + 1;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x - 2;
			to.y = lPiece->pos.y - 1;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x - 2;
			to.y = lPiece->pos.y + 1;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x + 1;
			to.y = lPiece->pos.y - 2;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x + 1;
			to.y = lPiece->pos.y + 2;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x - 1;
			to.y = lPiece->pos.y + 2;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x - 1;
			to.y = lPiece->pos.y - 2;
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			break;
		case BPWN:
		case WPWN:
			to.x = lPiece->pos.x;
			to.y = lPiece->pos.y + 1;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      if ((lPiece->fig == WPWN) && (to.y == 7)) lMove.promotion = WQEN; // Roland
      else if ((lPiece->fig == BPWN) && (to.y == 0)) lMove.promotion = BQEN;
      else lMove.promotion = EMPT; 
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x;
			to.y = lPiece->pos.y + 2;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
      if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x;
			to.y = lPiece->pos.y - 1;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      if ((lPiece->fig == WPWN) && (to.y == 7)) lMove.promotion = WQEN; // Roland
      else if ((lPiece->fig == BPWN) && (to.y == 0)) lMove.promotion = BQEN;
      else lMove.promotion = EMPT;
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x;
			to.y = lPiece->pos.y - 2;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      lMove.promotion = EMPT; // Roland
      if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x + 1;
			to.y = lPiece->pos.y + 1;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      if ((lPiece->fig == WPWN) && (to.y == 7)) lMove.promotion = WQEN; // Roland
      else if ((lPiece->fig == BPWN) && (to.y == 0)) lMove.promotion = BQEN;
      else lMove.promotion = EMPT;
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x + 1;
			to.y = lPiece->pos.y - 1;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      if ((lPiece->fig == WPWN) && (to.y == 7)) lMove.promotion = WQEN; // Roland
      else if ((lPiece->fig == BPWN) && (to.y == 0)) lMove.promotion = BQEN;
      else lMove.promotion = EMPT;
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x - 1;
			to.y = lPiece->pos.y + 1;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      if ((lPiece->fig == WPWN) && (to.y == 7)) lMove.promotion = WQEN; // Roland
      else if ((lPiece->fig == BPWN) && (to.y == 0)) lMove.promotion = BQEN;
      else lMove.promotion = EMPT;
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
			to.x = lPiece->pos.x - 1;
			to.y = lPiece->pos.y - 1;
			SquareToStr(lPiece->pos, &lMoveStr[0]);
			SquareToStr(to, &lMoveStr[2]);
			lMove.from = lPiece->pos;
			lMove.to = to;
      if ((lPiece->fig == WPWN) && (to.y == 7)) lMove.promotion = WQEN; // Roland
      else if ((lPiece->fig == BPWN) && (to.y == 0)) lMove.promotion = BQEN;
      else lMove.promotion = EMPT;
			if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
				aList[mp] = lMove;
				mp++;
				if (MM)
					return 1;
			}
		}
		i++;
	}
	/* KRALe si nechame az na konec */
	lPiece = &(lPlayer->pieces[0]);
	if ((lPiece->fig == WKNG) || (lPiece->fig == BKNG)) {
		to.x = lPiece->pos.x;
		to.y = lPiece->pos.y;
		/* rochada */
		to.x = lPiece->pos.x + 2;
		to.y = lPiece->pos.y;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x - 2;
		to.y = lPiece->pos.y;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		/* end of rochada */
		to.x = lPiece->pos.x + 1;
		to.y = lPiece->pos.y;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x + 1;
		to.y = lPiece->pos.y - 1;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x + 1;
		to.y = lPiece->pos.y + 1;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x;
		to.y = lPiece->pos.y - 1;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x;
		to.y = lPiece->pos.y + 1;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x - 1;
		to.y = lPiece->pos.y - 1;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x - 1;
		to.y = lPiece->pos.y;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
		to.x = lPiece->pos.x - 1;
		to.y = lPiece->pos.y + 1;
		lMove.from = lPiece->pos;
		lMove.to = to;
    lMove.promotion = EMPT; // Roland
		SquareToStr(lPiece->pos, &lMoveStr[0]);
		SquareToStr(to, &lMoveStr[2]);
		if (IsMoveStr(lMoveStr) && IsLegalMove(lMoveStr, aGame, 0)) {
			aList[mp] = lMove;
			mp++;
			if (MM)
				return 1;
		}
	} else {
		printf("DEBUG: Nulta figura != KRAL ??? BUG!\n");
		PrintPieces(*aGame);
	}
	return mp;
}

void MoveGenKolm(TGame * aGame, TMoveList aList, int *mp, int FIG, int MM)
{
	int x, y, i, pv = 0;
	TPieceData v[2];
	TSquare to;
	TMove lMove;
	char lMoveStr[5];
	if (aGame->sidetomove == WHITE) {
		i = 1;
		while (i < 16) {
			while (i < 16 && aGame->whiteplayer.pieces[i].fig != FIG)
				i++;
			if (i < 16) {
				v[pv] = aGame->whiteplayer.pieces[i];
				pv++;
				i++;
			}
		}
	} else {
		i = 1;
		while (i < 16) {
			while (i < 16 && aGame->blackplayer.pieces[i].fig != FIG)
				i++;
			if (i < 16) {
				v[pv] = aGame->blackplayer.pieces[i];
				pv++;
				i++;
			}
		}
	}
	for (i = 0; i < pv; i++) {
		/* doprava */
		x = v[i].pos.x + 1;
		y = v[i].pos.y;
		SquareToStr(v[i].pos, &lMoveStr[0]);
		lMove.from = v[i].pos;
		while (x <= 7 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			x++;
		}		/* while doprava ... EMPT */
		if (x <= 7) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni doprava ( braci ) */
		/* doleva */
		x = v[i].pos.x - 1;
		while (x >= 0 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			x--;
		}		/* while doleva ... EMPT */
		if (x >= 0) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni doleva ( braci ) */
		/* dolu */
		x = v[i].pos.x;
		y = v[i].pos.y - 1;
		while (y >= 0 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			y--;
		}		/* while dolu ... EMPT */
		if (y >= 0) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni dolu ( braci ) */
		/* nahoru */
		x = v[i].pos.x;
		y = v[i].pos.y + 1;
		while (y <= 7 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			y++;
		}		/* while nahoru ... EMPT */
		if (y <= 7) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni dolu ( braci ) */
	}			/* for i */
}

void MoveGenSikm(TGame * aGame, TMoveList aList, int *mp, int FIG, int MM)
{
	int x, y, i, pv = 0;
	TPieceData v[2];
	TSquare to;
	TMove lMove;
	char lMoveStr[5];
	if (aGame->sidetomove == WHITE) {
		i = 1;
		while (i < 16) {
			while (i < 16 && aGame->whiteplayer.pieces[i].fig != FIG)
				i++;
			if (i < 16) {
				v[pv] = aGame->whiteplayer.pieces[i];
				pv++;
				i++;
			}
		}
	} else {
		i = 1;
		while (i < 16) {
			while (i < 16 && aGame->blackplayer.pieces[i].fig != FIG)
				i++;
			if (i < 16) {
				v[pv] = aGame->blackplayer.pieces[i];
				pv++;
				i++;
			}
		}
	}
	for (i = 0; i < pv; i++) {
		/* doprava nahoru */
		x = v[i].pos.x + 1;
		y = v[i].pos.y + 1;
		SquareToStr(v[i].pos, &lMoveStr[0]);
		lMove.from = v[i].pos;
		while (x <= 7 && y <= 7 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			x++;
			y++;
		}		/* while doprava ... EMPT */
		if (x <= 7 && y <= 7) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni doprava a nahoru ( braci ) */
		/* doleva a nahoru */
		x = v[i].pos.x - 1;
		y = v[i].pos.y + 1;
		while (x >= 0 && y <= 7 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			x--;
			y++;
		}		/* while doleva a nahoru ... EMPT */
		if (x >= 0 && y <= 7) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni doleva a nahoru ( braci ) */
		/* doprava dolu */
		x = v[i].pos.x + 1;
		y = v[i].pos.y - 1;
		SquareToStr(v[i].pos, &lMoveStr[0]);
		lMove.from = v[i].pos;
		while (x <= 7 && y >= 0 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			x++;
			y--;
		}		/* while doprava ... EMPT */
		if (x <= 7 && y >= 0) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni doprava a dolu ( braci ) */
		/* doleva a dolu */
		x = v[i].pos.x - 1;
		y = v[i].pos.y - 1;
		while (x >= 0 && y >= 0 && aGame->board[x][y] == EMPT) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
			x--;
			y--;
		}		/* while doleva a nahoru ... EMPT */
		if (x >= 0 && y >= 0) {
			to.x = x;
			to.y = y;
			SquareToStr(to, &lMoveStr[2]);
			if (IsLegalMove(lMoveStr, aGame, 0)) {
				lMove.to = to;
        lMove.promotion = EMPT;
				aList[*mp] = lMove;
				(*mp)++;
				if (MM)
					return;
			}
		}		/* posledni (braci) */
	}			/* for i */
}

int SMoveGen(TGame * aGame, TMoveList aList)
{
	int p, i, c = 0;
	p = MoveGen(aGame, aList, 0);
	for (i = 0; i < p; i++)
		if (SMove(aGame, aList[i])) {
			aList[c] = aList[i];
			c++;
		}
	return (c);
}
