/*
 *    makemove.c
 *              - provadeni tahu a vyber tahu
 *
 */

#include <stdio.h>
#include <string.h>
#include <time.h>
#include "data.h"

extern int IQ, SIQ;
extern TMove historie[MAXMOVHIS];	/* 1.tah = [1] */

void MakeMove(char *c, TGame * H)
{
	/* TPieceData *fig,*brfig; - predelano na integery - indexy */
	int fi, brfi, vez;
	TSquare from, to, tmpoz;
	TMove move;
	Not2Num(&c[0], &from);
	Not2Num(&c[2], &to);
	move.from = from;
	move.to = to;
	/* najit figuru */
	switch (H->sidetomove) {
	case WHITE:
		if (!FindPiece(from, H->board, &(H->whiteplayer), &fi)) {
			printf("Nesrovnalost board a figur!!!");
			PrintBoard(*H);
			printf("%s", c);
			return;
		}
		break;
	case BLACK:
		if (!FindPiece(from, H->board, &(H->blackplayer), &fi)) {
			printf("DEBUG: Inconsistent data on board!!!");
			PrintBoard(*H);
			printf("%s", c);
			return;
		}
		break;
	}
	/* zmen POS u pieces ... */
	switch (H->sidetomove) {
	case WHITE:
		H->whiteplayer.pieces[fi].pos = to;
		if (H->whiteplayer.pieces[fi].fig == WKNG) {
			H->whiteplayer.rochada[0] = 0;
			H->whiteplayer.rochada[1] = 0;
		} else if ((H->whiteplayer.pieces[fi].fig == WROK)) {
			if (from.x == 7)
				H->whiteplayer.rochada[0] = 0;
			if (from.x == 0)
				H->whiteplayer.rochada[1] = 0;
		}
		break;
	case BLACK:
		H->blackplayer.pieces[fi].pos = to;
		if (H->blackplayer.pieces[fi].fig == BKNG) {
			H->blackplayer.rochada[0] = 0;
			H->blackplayer.rochada[1] = 0;
		} else if ((H->blackplayer.pieces[fi].fig == BROK)) {
			if (from.x == 7)
				H->blackplayer.rochada[0] = 0;
			if (from.x == 0)
				H->blackplayer.rochada[1] = 0;
		}
		break;
	}
	/* pokud bere nejakou figuru, tak vyres protihrace */
	if (H->board[to.x][to.y] != EMPT) {
		/* pokud se tahne na rohova pole, zakaz prislusne rochady */
		if (to.x == 0 && to.y == 0)
			H->whiteplayer.rochada[1] = 0;
		else if (to.x == 7 && to.y == 0)
			H->whiteplayer.rochada[0] = 0;
		else if (to.x == 0 && to.y == 7)
			H->blackplayer.rochada[1] = 0;
		else if (to.x == 7 && to.y == 7)
			H->blackplayer.rochada[0] = 0;
		switch (H->sidetomove) {
		case BLACK:
			if (!FindPiece(to, H->board, &(H->whiteplayer), &brfi)) {
				printf("DEBUG: Inconsistent data on board!!!");
				PrintBoard(*H);
				printf("%s", c);
				return;
			}
			break;
		case WHITE:
			if (!FindPiece(to, H->board, &(H->blackplayer), &brfi)) {
				printf("DEBUG: Inconsistent data on board!!!");
				PrintBoard(*H);
				printf("%s", c);
				return;
			}
			break;
		}
		/* ted odebrat figuru z protihracovych figurek */
		switch (H->sidetomove) {
		case BLACK:
			H->whiteplayer.pieces[brfi].fig = EMPT;
			RemovePiece(&(H->whiteplayer));
			break;
		case WHITE:
			H->blackplayer.pieces[brfi].fig = EMPT;
			RemovePiece(&(H->blackplayer));
			break;
		}
	}
	/* "to" == EMPT  ...  ==> */
	else if ((H->enpas == move.to.x) &&
		 ((H->board[from.x][from.y] == BPWN) ||
		  (H->board[from.x][from.y] == WPWN)) &&
		 (move.to.x != move.from.x))
		/* hraji na enpas sloupec a navic sikmo na EMPT => ENPAS */
		/* ;-) navic hraji nejakym pindikem */
		/* ^^ toto je spravne, pokud je IsLegalMove spravny */
	{
		switch (H->sidetomove) {
		case WHITE:
			tmpoz.y = 4;
			break;
		case BLACK:
			tmpoz.y = 3;
			break;
		}
		tmpoz.x = H->enpas;
		switch (H->sidetomove) {
		case BLACK:
			if (!FindPiece(tmpoz, H->board, &(H->whiteplayer), &brfi)) {
				printf("DEBUG: Inconsistent data on board!!!");
				PrintBoard(*H);
				printf("%s", c);
				return;
			}
			break;
		case WHITE:
			if (!FindPiece(tmpoz, H->board, &(H->blackplayer), &brfi)) {
				printf("DEBUG: Inconsistent data on board!!!");
				PrintBoard(*H);
				printf("%s", c);
				return;
			}
			break;
		}
		/* ted odebrat pesce z protihracovych figurek */
		switch (H->sidetomove) {
		case BLACK:
			H->whiteplayer.pieces[brfi].fig = EMPT;
			RemovePiece(&(H->whiteplayer));
			break;
		case WHITE:
			H->blackplayer.pieces[brfi].fig = EMPT;
			RemovePiece(&(H->blackplayer));
			break;
		}
		/* jeste ji zrusit na sachovnici */
		H->board[tmpoz.x][tmpoz.y] = EMPT;
	}			/* end of ENPASSANT - odebrano z figur, odebrano z board */
	/* hejbni prislusnou figurou na sachovnici */
	H->board[to.x][to.y] = H->board[from.x][from.y];
	H->board[from.x][from.y] = EMPT;
	switch (H->sidetomove) {	/* nastavi promennou enpas */
	case WHITE:
		if ((H->whiteplayer.pieces[fi].fig == WPWN) &&
		    (to.y - from.y == 2))
			H->enpas = to.x;
		else
			H->enpas = -1;
		break;
	case BLACK:
		if ((H->blackplayer.pieces[fi].fig == BPWN) &&
		    (to.y - from.y == -2))
			H->enpas = to.x;
		else
			H->enpas = -1;
		break;
	}
	/* pokud je rochada, hejbni jeste vezema */
	if (((H->sidetomove == WHITE) && (H->whiteplayer.pieces[fi].fig == WKNG)) ||
	  ((H->sidetomove == BLACK) && (H->blackplayer.pieces[fi].fig == BKNG))) {
		if (strcmp(c, "e1g1") == 0) {
			H->whiteplayer.rochada[2] = 1;
			tmpoz.x = 7;
			tmpoz.y = 0;
			if (!FindPiece(tmpoz, H->board, &(H->whiteplayer), &vez))
				printf("%s - Ta VEZ by tam mela bejt !!! :( => BUG\n", c);
			else {
				tmpoz.x = 5;
				H->whiteplayer.pieces[vez].pos = tmpoz;
				H->board[7][0] = EMPT;
				H->board[5][0] = WROK;
			}
		} else if (strcmp(c, "e1c1") == 0) {
			H->whiteplayer.rochada[2] = 1;
			tmpoz.x = 0;
			tmpoz.y = 0;
			if (!FindPiece(tmpoz, H->board, &(H->whiteplayer), &vez))
				printf("%s - Ta VEZ by tam mela bejt !!! :( => BUG\n", c);
			else {
				tmpoz.x = 3;
				H->whiteplayer.pieces[vez].pos = tmpoz;
				H->board[0][0] = EMPT;
				H->board[3][0] = WROK;
			}
		} else if (strcmp(c, "e8g8") == 0) {
			H->blackplayer.rochada[2] = 1;
			tmpoz.x = 7;
			tmpoz.y = 7;
			if (!FindPiece(tmpoz, H->board, &(H->blackplayer), &vez)) {
				printf("%s - Ta VEZ by tam mela bejt !!! :( => BUG\n", c);
				PrintBoard(*H);
				PrintPieces(*H);
				printf(" --- %d\n ", H->blackplayer.rochada[1]);
			} else {
				tmpoz.x = 5;
				H->blackplayer.pieces[vez].pos = tmpoz;
				H->board[7][7] = EMPT;
				H->board[5][7] = BROK;
			}
		} else if (strcmp(c, "e8c8") == 0) {
			H->blackplayer.rochada[2] = 1;
			tmpoz.x = 0;
			tmpoz.y = 7;
			if (!FindPiece(tmpoz, H->board, &(H->blackplayer), &vez))
				printf("Ta VEZ by tam mela bejt !!! :( => BUG\n");
			else {
				tmpoz.x = 3;
				H->blackplayer.pieces[vez].pos = tmpoz;
				H->board[0][7] = EMPT;
				H->board[3][7] = BROK;
			}
		}
	}			/* end of HEJBANI VEZema pri rochade */
	/* pokud pesec dorazi na konec, zmen ho na DAMu */
	if (((H->sidetomove == WHITE) && (H->whiteplayer.pieces[fi].fig == WPWN) &&
	     (to.y == 7)) ||
	    ((H->sidetomove == BLACK) && (H->blackplayer.pieces[fi].fig == BPWN) &&
	     (to.y == 0))) {	/* budeme menit */
		switch (H->sidetomove) {
		case WHITE:
			H->whiteplayer.pieces[fi].fig = WQEN;
			H->board[to.x][to.y] = WQEN;
			break;
		case BLACK:
			H->blackplayer.pieces[fi].fig = BQEN;
			H->board[to.x][to.y] = BQEN;
			break;
		}
	}
	/* update historie tahu */
	(H->PHT)++;
	historie[H->PHT] = move;
	/* prohodit hrace na tahu */
	if (H->sidetomove == WHITE)
		H->sidetomove = BLACK;
	else
		H->sidetomove = WHITE;
    /* TODO: 50 tahu bez vymeny, bez tahu pescem... remiza */
}

int BestMove(TGame * aGame, char aMoveStr[/*5*/6], int vv)
{
	static TGame lGame;
	TMoveList lList;
	int p, i, k = 1, best, bestval, t, hod[MAXMOVGEN], siq = SIQ, vvv;
	time_t t1, t2;
	time(&t1);
	p = MoveGen(aGame, lList, 0);
	if (p == 0)
		return -1;
	vvv = vv && printf("\n");
  if (p == 1) {
      best = 0;
      t2 = t1;
  } else
      while (1) {
          vvv = vv && printf("Depth <%d,%2d> %3d%%", k, siq, 0);
          best = -1;
          bestval = -MATV - 1;	/* pokud najde mat ... */
          for (i = 0; i < p; i++) {
              lGame = *aGame;
              SquareToStr(lList[i].from, &aMoveStr[0]);
              SquareToStr(lList[i].to, &aMoveStr[2]);
              MakeMove(aMoveStr, &lGame);
              t = -AlfaBeta(&lGame, k - 1, -MATV, -bestval);
              hod[i] = t;
              if (t > bestval) {
                  best = i;
                  bestval = t;
              }
              vvv = vv && printf("\b\b\b\b%3d%%", (i + 1) * 100 / p);
          }
          time(&t2);
          vvv = vv && printf(" (%3lds)\n", t2 - t1);
          /* TODO make this better */
          if ( ( ((t2-t1)*5) * (aGame->tmoves - (((aGame->PHT+1))/2)%aGame->tmoves)) 
                  > aGame->tleft )
              break;
          else {
              Sort(lList, hod, p);
              k++;
          }
      }
	SquareToStr(lList[best].from, &aMoveStr[0]);
	SquareToStr(lList[best].to, &aMoveStr[2]); if (vvv) {};
  if (lList[best].promotion != EMPT) PromotionToStr(lList[best].promotion, &aMoveStr[4]);
	return (t2 - t1 + 1);
}
