/*
 *    search.c
 *
 *      alfa-beta vyhledavaci funkce
 *
 */

#include"data.h"

int SAlfaBeta(TGame *, int, int, int, int);	/* silent alfa-beta */

extern int IQ, SIQ;

int AlfaBeta(TGame * H, int depth, int alpha, int beta)
{
	TGame temp;
	TMoveList mg;
	int best, p, i = 0, value;
	char c[5];

	if (depth <= 0) {
		if (SIQ < 0)
			return SAlfaBeta(H, depth, alpha, beta, 0);
		else
			return Evaluate(H);
	}
	p = MoveGen(H, mg, 0);

	if (p == 0)
		return Evaluate(H);

	best = -MATV;
	while (i < p && best < beta) {
		temp = *H;
		SquareToStr(mg[i].from, &c[0]);
		SquareToStr(mg[i].to, &c[2]);
		MakeMove(c, &temp);
		if (best > alpha)
			alpha = best;
		value = -AlfaBeta(&temp, depth - 1, -beta, -alpha);
		if (value > best)
			best = value;
		i++;
	}

	return best;
}

int SAlfaBeta(TGame * H, int depth, int alpha, int beta, int nt)
{
	TGame temp;
	TMoveList mg;
	int best, p, i = 0, value;
	char c[5];

	if (depth <= SIQ) {
		if (depth < 0)
			return EvaluateM(H);
		else
			return Evaluate(H);
	}
	p = SMoveGen(H, mg);

	best = -MATV;
	while (i < p && best < beta) {
		temp = *H;
		SquareToStr(mg[i].from, &c[0]);
		SquareToStr(mg[i].to, &c[2]);
		MakeMove(c, &temp);
		if (best > alpha)
			alpha = best;
		value = -SAlfaBeta(&temp, depth - 1, -beta, -alpha, 0);
		if (value > best)
			best = value;
		i++;
	}
	/* vygenerovat take NULL tah */
	/* jinak bude napriklad nucen delat nevyhodne
	   braci tahy */
	if (nt == 0) {
		temp = *H;
		if (H->sidetomove == WHITE)
			temp.sidetomove = BLACK;
		else
			temp.sidetomove = WHITE;
		temp.enpas = -1;	/* no enpassant while NULL move */
		value = -SAlfaBeta(&temp, depth - 1, -beta, -alpha, 1);
		if (value > best)
			best = value;
	} else if (nt == 1 && p == 0)
		return EvaluateM(H);

	return best;
}
