/*
 *    value.c
 *      =======
 *      - ohodnoceni pozice
 *              Martin Macok
 */

#include"data.h"

#define abs(x) (x>0 ? x : -x)
#define sign(x) (x==0 ? 0 : x / abs(x))

int Evaluate(TGame * H)
{				/* mat pat + matros */
	int p;
	TMoveList mg;
	p = MoveGen(H, mg, 1);
	/* urychleni by se ^^ melo dosahnout tim, ze negenerujeme vsechny tahy,
	   ale skoncime pri nalezeni prvniho ... */
	if (p == 0) {
		if (InCheck(H->sidetomove, H))	/* MAT */
			return -MATV;
		else
			return 0;	/* PAT */
	} else
		return EvaluateM(H);
}

int EvaluateM(TGame * H)
{
	int i, v = 0,x,y, b2s = 0, c2s = 0;
	v += 2*(H->whiteplayer.rochada[0] - H->blackplayer.rochada[0]);
	v += H->whiteplayer.rochada[1] - H->blackplayer.rochada[1];
	v += H->whiteplayer.rochada[2] - H->blackplayer.rochada[2];
	v += 2*(sign(H->board[3][3]) + sign(H->board[3][4]) 
            + sign(H->board[4][3]) + sign(H->board[4][4]));
	v += sign(H->board[2][2]) + 
         sign(H->board[2][3]) + 
         sign(H->board[2][4]) + 
         sign(H->board[2][5]) + 
         sign(H->board[3][2]) + 
         sign(H->board[3][5]) + 
         sign(H->board[4][2]) + 
         sign(H->board[4][5]) + 
	     sign(H->board[5][2]) + 
         sign(H->board[5][3]) + 
         sign(H->board[5][4]) + 
         sign(H->board[5][5]);
	for (i = 1; i < 16; i++) {
		switch (H->whiteplayer.pieces[i].fig) {
		case WPWN:
			v += PWNV;
            if (H->whiteplayer.pieces[i].pos.x > 4) v++;
            if (H->whiteplayer.pieces[i].pos.x > 5) v++;
			break;
		case WKNT:
			v += KNTV;
            x = H->whiteplayer.pieces[i].pos.x;
            y = H->whiteplayer.pieces[i].pos.y;
            if (x > 0 && y > 0 && x < 7 && y < 7) v++;
			break;
		case WBSP:
			v += BSPV;
            b2s++;
            if (b2s > 1) v++;
			break;
		case WROK:
			v += ROKV;
			break;
		case WQEN:
			v += QENV;
			break;
		}
		switch (H->blackplayer.pieces[i].fig) {
		case BPWN:
			v -= PWNV;
            if (H->blackplayer.pieces[i].pos.x < 3) v--;
            if (H->blackplayer.pieces[i].pos.x < 2) v--;
			break;
		case BKNT:
			v -= KNTV;
            x = H->blackplayer.pieces[i].pos.x;
            y = H->blackplayer.pieces[i].pos.y;
            if (x > 0 && y > 0 && x < 7 && y < 7) v--;
			break;
		case BBSP:
			v -= BSPV;
            c2s++;
            if (c2s > 1) v--;
			break;
		case BROK:
			v -= ROKV;
			break;
		case BQEN:
			v -= QENV;
			break;
		}
	}
	if (H->sidetomove == WHITE)
		return v;
	else
		return -v;
}
